if(!strLen($Pref::Server::FillPrinter_MaxBricks))
   $Pref::Server::FillPrinter_MaxBricks=500;

function printfill(%client,%obj,%newPrint)
{
   %oldPrint=%obj.printID;
   if(%client.isAdmin || %client.isSuperAdmin)
      %limit=128000;
   else
      %limit=$pref::server::fillPrinter_maxbricks;
   %fillcount=0;
   %list=new ScriptObject()
   {
      count=-1;
      oldprint=%oldPrint;
      newprint=%newPrint;
   };
   missioncleanup.add(%list);
   %list.obj[%list.count++]=%obj;
   %obj.fill=1;
   for(%x=0;%x<=%list.count;%x++)
   {
      %obj=%list.obj[%x];
      %obj.setPrint(%newPrint);
      %fillcount++;
      if(%fillcount>=%limit)
      {
         messageclient(%client,'MsgPlantError_Limit');
         centerprint(%client,"\c3Reached Fill Print Brick Limit ("@$pref::server::fillPrinter_maxbricks@")",2,3);
         break;
      }
      %data=%obj.getdatablock();
      %rot=mRound(getword(%obj.rotation,3));
      if(%rot==90 || %rot==270)
      {
         %sizex=%data.bricksizey;
         %sizey=%data.bricksizex;
      }
      else
      {
         %sizex=%data.bricksizex;
         %sizey=%data.bricksizey;
      }
      %sizez=%data.bricksizez;
      %box=(%sizex*0.5+0.6) SPC (%sizey*0.5+0.6) SPC (%sizez*0.2+0.3);
      InitContainerBoxSearch(%obj.getposition(),%box,$typemasks::fxbrickobjecttype);
      while(%target=containerSearchNext())
      {
         if(%target.isplanted() && %target.printID==%oldPrint)
         {
            if(gettrustlevel(%client,%target)>=2)
            {
               if(!%target.fill)
               {
                  %target.fill=1;
                  %list.obj[%list.count++]=%target;
               }
            }
         }
      }
   }
   for(%x=0;%x<=%list.count;%x++)
      %list.obj[%x].fill=0;
   %client.undostack.push(%list TAB "FILLPRINT");
}

datablock ParticleData(fillPrinterParticle:PrintGunParticle)
{
   colors[0] = "0.75 0.25 0.75 0.5";
   colors[1] = "0.75 0.25 0.75 0";
};

datablock ParticleEmitterData(fillPrinterEmitter:printGunEmitter)
{
   particles = "fillPrinterParticle";
   uiname = "Fill Printer";
};

datablock ItemData(fillPrinterItem : PrintGun)
{
   uiName = "Fill Printer";
   doColorShift = true;
   colorShiftColor = "1 0 1 1";
   image = fillPrinterImage;
};

datablock ShapeBaseImageData(fillPrinterImage : PrintGunImage)
{
   minShotTime = 700;
   doColorShift = true;
   stateEmitter[2] = "fillPrinterEmitter";
   colorShiftColor = fillPrinterItem.colorShiftColor;
};
function fillPrinterImage::onFire(%this,%obj,%slot)
{
   %mask = ($typeMasks::FxBrickObjectType | $typeMasks::FxBrickAlwaysObjectType);
   %ray = containerRaycast(%obj.getEyePoint(),vectorAdd(%obj.getEyePoint(),vectorScale(%obj.getEyeVector(),10)),%mask,%obj);
   %col=firstWord(%ray);
   if(isObject(%col))
      fillPrinterImage::onHitObject(%this,%obj,%col,posFromRaycast(%ray),normalFromRaycast(%ray));
}
function fillPrinterImage::onHitObject(%this,%obj,%col,%pos,%normal){
   %client=%obj.client;
   if(!isobject(%client))
      return;
   if(%col.getclassname()$=fxdtsbrick)
   {
      %data = %col.getDatablock();
      if(%data.hasPrint)
      {
         if(gettrustlevel(%client,%col)>=2)
         {
            %client.fillPrintBrick=%col;
            %client.PrintBrick=0;
            commandtoclient(%client,'openPrintSelectorDlg',%data.printAspectRatio);
         }
         else
            centerprint(%client,%col.getgroup().getTrustFailureMessage(),3,3);
         }
   }
}

function servercmdfillPrinter(%client)
{
   if(isobject(%client.minigame))
   {
      if(!%client.minigame.enablepainting)
      {
         centerprint(%client,"\c5Painting is currently disabled.",3,3);
         return;
      }
   }
   %client.player.updatearm(fillPrinterimage);
   %client.player.mountimage(fillPrinterimage,0);
}

package fillPrinter
{
   function servercmdundobrick(%client)
   {
      %str=%client.undostack.val[%client.undostack.head-1];
      if(getfield(%str,1)$="FILLPRINT")
      {
         %list=getfield(%str,0);
         for(%x=%list.count;%x>-1;%x--)
         {
            %b=%list.obj[%x];
            if(isobject(%b))
            {
               if(%b.printID==%list.newPrint)
                  %b.setPrint(%list.oldPrint);
            }
         }
         %client.undostack.pop();
         %list.delete();
         %client.player.playthread(0,undo);
      }
      else
         parent::servercmdundobrick(%client);
   }
   function servercmdSetPrint(%obj,%id)
   {
      if(isObject(%obj.fillPrintBrick)&&!isObject(%obj.PrintBrick))
      {
         %brick=%obj.fillPrintBrick;
         %obj.fillPrintBrick=0;
         printfill(%obj,%brick,%id);
      }
      else
      {
         %obj.fillPrintBrick=0;
         Parent::servercmdSetPrint(%obj,%id);
      }
   }
   function gameconnection::onclientleavegame(%client)
   {
      for(%x=%client.undostack.tail;%x<%client.undostack.head;%x++)
      {
         %t=%client.undostack.val[%x];
         if(getword(%t,1)$="FILLPRINT")
            getword(%t,0).delete();
      }
      parent::onclientleavegame(%client);
   }
};
activatepackage(fillPrinter);

function mRound(%a){
   return mFloatLength(%a,0);
}